Monday, February 6, 2017

Leetcode/各大家 -- 377. Combination Sum IV(DP)

377. Combination Sum IV (DP)
medium

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.
Example:
nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7.
Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?

思路1:DP - Fill each dp[i] from 0 to target indicating the possibilites to sum to i;
          To fill each dp[i], we check through nums and pick any of element possible, at which it has target dp[target-nums[i]] possibility
public class Solution {
    public int combinationSum4(int[] nums, int target) {
        int[] dp = new int[target + 1];
        dp[0] = 1;
        for(int i = 1; i <= target; i++){//fill dp[i], indicates ways to sum to i
            for(int j = 0; j < nums.length; j++){//calculate each dp[i]
                if(i - nums[j] >= 0){
                    dp[i] += dp[i - nums[j]];  
                } 
            }
        }
        return dp[target];
    }
}
eg:
nums[1,2,3] target = 4

dp[0, 1, 2, 3, 4] return dp[4]
   1, 1, 2, 4, 7
dp[4] = dp[4-1] + dp[4-2] + dp[4-3] = dp[3] + comb[2] + comb[1].
7 is from  1(dp of nums[0] = dp[1])+2(dp of nums[1])+4(dp of nums[2])
To get 4, when at dp[4], we can choose any num[i] in nums and so it will have target-nums[i] possibility

思路2: top-down recursion with hashmap
https://discuss.leetcode.com/topic/52255/java-recursion-solution-using-hashmap-as-memory

No comments:

Post a Comment